curl --request POST \
--url https://api.messaging.phonovation.com/communication/1/flows/{campaignId}/participants \
--header 'Authorization: <api-key>' \
--header 'Content-Type: application/json' \
--data '
{
"personData": {
"externalId": "1",
"firstName": "Jane",
"lastName": "Smith",
"address": "67 Farringdon Road",
"city": "London",
"country": "United Kingdom",
"gender": "FEMALE",
"birthDate": "1966-01-15",
"middleName": "Janie",
"profilePicture": "http://profile.com",
"tags": [
"VIP Customers",
"New Customers"
],
"customAttributes": {
"Contract Expiry": "2018-06-01",
"Company": "Acme"
},
"contactInformation": {
"phone": [
{
"number": "353861234579"
},
{
"number": "353861234580"
}
],
"email": [
{
"address": "jane@acme.com"
},
{
"address": "janesmith@acme.com"
}
]
}
},
"flowVariables": {
"orderDate": "2021-09-01",
"orderDetails": "Extended Weight, Discount",
"orderNumber": 1234567
}
}
'import requests
url = "https://api.messaging.phonovation.com/communication/1/flows/{campaignId}/participants"
payload = {
"personData": {
"externalId": "1",
"firstName": "Jane",
"lastName": "Smith",
"address": "67 Farringdon Road",
"city": "London",
"country": "United Kingdom",
"gender": "FEMALE",
"birthDate": "1966-01-15",
"middleName": "Janie",
"profilePicture": "http://profile.com",
"tags": ["VIP Customers", "New Customers"],
"customAttributes": {
"Contract Expiry": "2018-06-01",
"Company": "Acme"
},
"contactInformation": {
"phone": [{ "number": "353861234579" }, { "number": "353861234580" }],
"email": [{ "address": "jane@acme.com" }, { "address": "janesmith@acme.com" }]
}
},
"flowVariables": {
"orderDate": "2021-09-01",
"orderDetails": "Extended Weight, Discount",
"orderNumber": 1234567
}
}
headers = {
"Authorization": "<api-key>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)using RestSharp;
var options = new RestClientOptions("https://api.messaging.phonovation.com/communication/1/flows/{campaignId}/participants");
var client = new RestClient(options);
var request = new RestRequest("");
request.AddHeader("Authorization", "<api-key>");
request.AddJsonBody("{\n \"personData\": {\n \"externalId\": \"1\",\n \"firstName\": \"Jane\",\n \"lastName\": \"Smith\",\n \"address\": \"67 Farringdon Road\",\n \"city\": \"London\",\n \"country\": \"United Kingdom\",\n \"gender\": \"FEMALE\",\n \"birthDate\": \"1966-01-15\",\n \"middleName\": \"Janie\",\n \"profilePicture\": \"http://profile.com\",\n \"tags\": [\n \"VIP Customers\",\n \"New Customers\"\n ],\n \"customAttributes\": {\n \"Contract Expiry\": \"2018-06-01\",\n \"Company\": \"Acme\"\n },\n \"contactInformation\": {\n \"phone\": [\n {\n \"number\": \"353861234579\"\n },\n {\n \"number\": \"353861234580\"\n }\n ],\n \"email\": [\n {\n \"address\": \"jane@acme.com\"\n },\n {\n \"address\": \"janesmith@acme.com\"\n }\n ]\n }\n },\n \"flowVariables\": {\n \"orderDate\": \"2021-09-01\",\n \"orderDetails\": \"Extended Weight, Discount\",\n \"orderNumber\": 1234567\n }\n}", false);
var response = await client.PostAsync(request);
Console.WriteLine("{0}", response.Content);
HttpResponse<String> response = Unirest.post("https://api.messaging.phonovation.com/communication/1/flows/{campaignId}/participants")
.header("Authorization", "<api-key>")
.header("Content-Type", "application/json")
.body("{\n \"personData\": {\n \"externalId\": \"1\",\n \"firstName\": \"Jane\",\n \"lastName\": \"Smith\",\n \"address\": \"67 Farringdon Road\",\n \"city\": \"London\",\n \"country\": \"United Kingdom\",\n \"gender\": \"FEMALE\",\n \"birthDate\": \"1966-01-15\",\n \"middleName\": \"Janie\",\n \"profilePicture\": \"http://profile.com\",\n \"tags\": [\n \"VIP Customers\",\n \"New Customers\"\n ],\n \"customAttributes\": {\n \"Contract Expiry\": \"2018-06-01\",\n \"Company\": \"Acme\"\n },\n \"contactInformation\": {\n \"phone\": [\n {\n \"number\": \"353861234579\"\n },\n {\n \"number\": \"353861234580\"\n }\n ],\n \"email\": [\n {\n \"address\": \"jane@acme.com\"\n },\n {\n \"address\": \"janesmith@acme.com\"\n }\n ]\n }\n },\n \"flowVariables\": {\n \"orderDate\": \"2021-09-01\",\n \"orderDetails\": \"Extended Weight, Discount\",\n \"orderNumber\": 1234567\n }\n}")
.asString();<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.messaging.phonovation.com/communication/1/flows/{campaignId}/participants",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'personData' => [
'externalId' => '1',
'firstName' => 'Jane',
'lastName' => 'Smith',
'address' => '67 Farringdon Road',
'city' => 'London',
'country' => 'United Kingdom',
'gender' => 'FEMALE',
'birthDate' => '1966-01-15',
'middleName' => 'Janie',
'profilePicture' => 'http://profile.com',
'tags' => [
'VIP Customers',
'New Customers'
],
'customAttributes' => [
'Contract Expiry' => '2018-06-01',
'Company' => 'Acme'
],
'contactInformation' => [
'phone' => [
[
'number' => '353861234579'
],
[
'number' => '353861234580'
]
],
'email' => [
[
'address' => 'jane@acme.com'
],
[
'address' => 'janesmith@acme.com'
]
]
]
],
'flowVariables' => [
'orderDate' => '2021-09-01',
'orderDetails' => 'Extended Weight, Discount',
'orderNumber' => 1234567
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: <api-key>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}const options = {
method: 'POST',
headers: {Authorization: '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
personData: {
externalId: '1',
firstName: 'Jane',
lastName: 'Smith',
address: '67 Farringdon Road',
city: 'London',
country: 'United Kingdom',
gender: 'FEMALE',
birthDate: '1966-01-15',
middleName: 'Janie',
profilePicture: 'http://profile.com',
tags: ['VIP Customers', 'New Customers'],
customAttributes: {'Contract Expiry': '2018-06-01', Company: 'Acme'},
contactInformation: {
phone: [{number: '353861234579'}, {number: '353861234580'}],
email: [{address: 'jane@acme.com'}, {address: 'janesmith@acme.com'}]
}
},
flowVariables: {
orderDate: '2021-09-01',
orderDetails: 'Extended Weight, Discount',
orderNumber: 1234567
}
})
};
fetch('https://api.messaging.phonovation.com/communication/1/flows/{campaignId}/participants', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));{
"errorCode": 40001,
"errorMessage": ""
}{
"requestError": {
"serviceException": {
"messageId": "UNAUTHORIZED",
"text": "Unauthorized"
}
}
}{
"requestError": {
"serviceException": {
"messageId": "FORBIDDEN",
"text": "Forbidden"
}
}
}{
"errorCode": 40001,
"errorMessage": ""
}{
"requestError": {
"serviceException": {
"messageId": "GENERAL_ERROR",
"text": "Something went wrong. Please contact support."
}
}
}Add Person to Flow
Creates or updates a person and adds it to Flow
Required scope: Enable one of: flow:use, flow:manage.
curl --request POST \
--url https://api.messaging.phonovation.com/communication/1/flows/{campaignId}/participants \
--header 'Authorization: <api-key>' \
--header 'Content-Type: application/json' \
--data '
{
"personData": {
"externalId": "1",
"firstName": "Jane",
"lastName": "Smith",
"address": "67 Farringdon Road",
"city": "London",
"country": "United Kingdom",
"gender": "FEMALE",
"birthDate": "1966-01-15",
"middleName": "Janie",
"profilePicture": "http://profile.com",
"tags": [
"VIP Customers",
"New Customers"
],
"customAttributes": {
"Contract Expiry": "2018-06-01",
"Company": "Acme"
},
"contactInformation": {
"phone": [
{
"number": "353861234579"
},
{
"number": "353861234580"
}
],
"email": [
{
"address": "jane@acme.com"
},
{
"address": "janesmith@acme.com"
}
]
}
},
"flowVariables": {
"orderDate": "2021-09-01",
"orderDetails": "Extended Weight, Discount",
"orderNumber": 1234567
}
}
'import requests
url = "https://api.messaging.phonovation.com/communication/1/flows/{campaignId}/participants"
payload = {
"personData": {
"externalId": "1",
"firstName": "Jane",
"lastName": "Smith",
"address": "67 Farringdon Road",
"city": "London",
"country": "United Kingdom",
"gender": "FEMALE",
"birthDate": "1966-01-15",
"middleName": "Janie",
"profilePicture": "http://profile.com",
"tags": ["VIP Customers", "New Customers"],
"customAttributes": {
"Contract Expiry": "2018-06-01",
"Company": "Acme"
},
"contactInformation": {
"phone": [{ "number": "353861234579" }, { "number": "353861234580" }],
"email": [{ "address": "jane@acme.com" }, { "address": "janesmith@acme.com" }]
}
},
"flowVariables": {
"orderDate": "2021-09-01",
"orderDetails": "Extended Weight, Discount",
"orderNumber": 1234567
}
}
headers = {
"Authorization": "<api-key>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)using RestSharp;
var options = new RestClientOptions("https://api.messaging.phonovation.com/communication/1/flows/{campaignId}/participants");
var client = new RestClient(options);
var request = new RestRequest("");
request.AddHeader("Authorization", "<api-key>");
request.AddJsonBody("{\n \"personData\": {\n \"externalId\": \"1\",\n \"firstName\": \"Jane\",\n \"lastName\": \"Smith\",\n \"address\": \"67 Farringdon Road\",\n \"city\": \"London\",\n \"country\": \"United Kingdom\",\n \"gender\": \"FEMALE\",\n \"birthDate\": \"1966-01-15\",\n \"middleName\": \"Janie\",\n \"profilePicture\": \"http://profile.com\",\n \"tags\": [\n \"VIP Customers\",\n \"New Customers\"\n ],\n \"customAttributes\": {\n \"Contract Expiry\": \"2018-06-01\",\n \"Company\": \"Acme\"\n },\n \"contactInformation\": {\n \"phone\": [\n {\n \"number\": \"353861234579\"\n },\n {\n \"number\": \"353861234580\"\n }\n ],\n \"email\": [\n {\n \"address\": \"jane@acme.com\"\n },\n {\n \"address\": \"janesmith@acme.com\"\n }\n ]\n }\n },\n \"flowVariables\": {\n \"orderDate\": \"2021-09-01\",\n \"orderDetails\": \"Extended Weight, Discount\",\n \"orderNumber\": 1234567\n }\n}", false);
var response = await client.PostAsync(request);
Console.WriteLine("{0}", response.Content);
HttpResponse<String> response = Unirest.post("https://api.messaging.phonovation.com/communication/1/flows/{campaignId}/participants")
.header("Authorization", "<api-key>")
.header("Content-Type", "application/json")
.body("{\n \"personData\": {\n \"externalId\": \"1\",\n \"firstName\": \"Jane\",\n \"lastName\": \"Smith\",\n \"address\": \"67 Farringdon Road\",\n \"city\": \"London\",\n \"country\": \"United Kingdom\",\n \"gender\": \"FEMALE\",\n \"birthDate\": \"1966-01-15\",\n \"middleName\": \"Janie\",\n \"profilePicture\": \"http://profile.com\",\n \"tags\": [\n \"VIP Customers\",\n \"New Customers\"\n ],\n \"customAttributes\": {\n \"Contract Expiry\": \"2018-06-01\",\n \"Company\": \"Acme\"\n },\n \"contactInformation\": {\n \"phone\": [\n {\n \"number\": \"353861234579\"\n },\n {\n \"number\": \"353861234580\"\n }\n ],\n \"email\": [\n {\n \"address\": \"jane@acme.com\"\n },\n {\n \"address\": \"janesmith@acme.com\"\n }\n ]\n }\n },\n \"flowVariables\": {\n \"orderDate\": \"2021-09-01\",\n \"orderDetails\": \"Extended Weight, Discount\",\n \"orderNumber\": 1234567\n }\n}")
.asString();<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.messaging.phonovation.com/communication/1/flows/{campaignId}/participants",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'personData' => [
'externalId' => '1',
'firstName' => 'Jane',
'lastName' => 'Smith',
'address' => '67 Farringdon Road',
'city' => 'London',
'country' => 'United Kingdom',
'gender' => 'FEMALE',
'birthDate' => '1966-01-15',
'middleName' => 'Janie',
'profilePicture' => 'http://profile.com',
'tags' => [
'VIP Customers',
'New Customers'
],
'customAttributes' => [
'Contract Expiry' => '2018-06-01',
'Company' => 'Acme'
],
'contactInformation' => [
'phone' => [
[
'number' => '353861234579'
],
[
'number' => '353861234580'
]
],
'email' => [
[
'address' => 'jane@acme.com'
],
[
'address' => 'janesmith@acme.com'
]
]
]
],
'flowVariables' => [
'orderDate' => '2021-09-01',
'orderDetails' => 'Extended Weight, Discount',
'orderNumber' => 1234567
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: <api-key>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}const options = {
method: 'POST',
headers: {Authorization: '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
personData: {
externalId: '1',
firstName: 'Jane',
lastName: 'Smith',
address: '67 Farringdon Road',
city: 'London',
country: 'United Kingdom',
gender: 'FEMALE',
birthDate: '1966-01-15',
middleName: 'Janie',
profilePicture: 'http://profile.com',
tags: ['VIP Customers', 'New Customers'],
customAttributes: {'Contract Expiry': '2018-06-01', Company: 'Acme'},
contactInformation: {
phone: [{number: '353861234579'}, {number: '353861234580'}],
email: [{address: 'jane@acme.com'}, {address: 'janesmith@acme.com'}]
}
},
flowVariables: {
orderDate: '2021-09-01',
orderDetails: 'Extended Weight, Discount',
orderNumber: 1234567
}
})
};
fetch('https://api.messaging.phonovation.com/communication/1/flows/{campaignId}/participants', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));{
"errorCode": 40001,
"errorMessage": ""
}{
"requestError": {
"serviceException": {
"messageId": "UNAUTHORIZED",
"text": "Unauthorized"
}
}
}{
"requestError": {
"serviceException": {
"messageId": "FORBIDDEN",
"text": "Forbidden"
}
}
}{
"errorCode": 40001,
"errorMessage": ""
}{
"requestError": {
"serviceException": {
"messageId": "GENERAL_ERROR",
"text": "Something went wrong. Please contact support."
}
}
}Authorizations
This is the most secure authorization type and the one with the most flexibility.
API keys can be generated by calling the dedicated API method. Furthermore, API keys can have a limited scope and cover only some API methods. Lastly, they can be revoked at any time. This range of possibilities makes API keys well suited for separating the API access rights across multiple applications or use cases. Finally, the loss of an API key is easily manageable.
You can manage your API keys from GUI, or programmatically with dedicated API.
API key Authorization header example:
Authorization: App 003026bbc133714df1834b8638bb496e-8f4b3d9a-e931-478d-a994-28a725159ab9
Path Parameters
Unique identifier of the flow that person will be added to
Query Parameters
Person's phone number
Person's email address
Unique ID for the person from an external system
Body
Contains the data used for person creation (if it does not exist) or partial update (if it exists)
Person attributes. In case a person with either the specified externalId or contactInformation already exists in the People, the persons will be automatically merged. See endpoint description for more info.
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Response
OK